#########################################################################################
#	                                                                              	#
#	      :::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::      	#
#	    ____                __                                                    	#
#	   / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __ 	#
#	  / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // / 	#
#	 /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/  	#
#	      /___/ /___/                 /_/    /_/           /___/ /_/              	#
#	                                                                              	#
#########################################################################################
#                                                                              		#
# form.tcl v1.0                                                                		#
#                                                                              		#
# :                                                                    		#
#       ,      .            		#
#         .           		#
#        .     ! .    . 	#
#                                                                              		#
# Author: Deniska@RusNet <deniska@eggdrop.org.ru>                              		#
#                                                                              		#
# Official support: irc.eggdrop.org.ru @ #eggdrop                              		#
#                                                                              		#
#########################################################################################
#											#
# :										#
#       1.   'form.tcl'   'eggdrop/scripts'.				#
#       2.    eggdrop.conf  'source scripts/form.tcl'.		#
#       3.   'quest.txt'  'prefix.txt'   'eggdrop/data',		#
#                .					#
#       4.      ,   		#
#          /.								#
#       :      .       #
#                    .						#
#       5.  '.rehash',   .					#
#											#
#											#
#########################################################################################
###  
##   ,     .
set form(pathtof) "scripts/forms.txt"

##       .
set form(pathtoq) "scripts/quest.txt"

##   ,     ""  .
##  :
##    - "   ?"
##     - " : "
##   - ""
##     ,  c 
##    - " : hangy"
set form(pathtop) "scripts/prefix.txt"


bind msg - ! forms

proc forms { nick uhost hand text } {
   global form

   if {![file exists $form(pathtoq)]} { return }
   set form(quest) [::egglib::readdata $form(pathtoq)]
   set form(prefix) [::egglib::readdata $form(pathtop)]
   if {![file exists $form(pathtof)]} {
   set fl [open $form(pathtof) w+]
   close $fl
   }
	if { ![info exists form(q,$uhost)]} { set form(q,$uhost) -1 }
	if { $form(q,$uhost) == -1 } {
	if { [string match "*" [::egglib::tolower $text]] || [string match "*" [::egglib::tolower $text]] || [::egglib::tolower $text] == "help" } {
	putserv "privmsg $nick : :"
	putserv "privmsg $nick :! //help -   "
	putserv "privmsg $nick :! //all -    "
	putserv "privmsg $nick :! /question -    "
	putserv "privmsg $nick :! /random -   "
	putserv "privmsg $nick :! /start -    "
	putserv "privmsg $nick :! /stop -   "
	if {[matchattr $hand mno|-]} {
	putserv "privmsg $nick :! /delete <> -     "
	}
	return
	}
	



	if { [string match "*" [::egglib::tolower $text]] || "delete" == [::egglib::tolower $text] } {
	if {![matchattr $hand mno|-]} { return }
	set num [lindex [split $text] 1]
	if { ![regexp -nocase -- {^[0-9]+} [lindex $text 1]] } {
	putserv "privmsg $nick :! /delete <>"
	return
	}
	set data [::egglib::readdata $form(pathtof)]
	set data [lreplace $data [expr $num-1] [expr $num-1]]
	::egglib::writedata $form(pathtof) $data
	putserv "privmsg $nick : #$num ."
	return
	}

	if { [string match "*" [::egglib::tolower $text]] || [string match "*" [::egglib::tolower $text]] || [::egglib::tolower $text] == "all" } {
	putserv "privmsg $nick :   [llength [::egglib::readdata $form(pathtof)]] ()."
	return
	}

	if { [string match "*" [::egglib::tolower $text]] || [string match "quest*" [::egglib::tolower $text]]} {
	putserv "privmsg $nick :   [llength $form(quest)] ."
	return
	}
	
	if { [::egglib::tolower $text] == "random" || [string match "*" [::egglib::tolower $text]] } {
	if {[llength [::egglib::readdata $form(pathtof)]] < 1 } {
	putserv "privmsg $nick :    ."
	return 
	}
	set rn [rand [llength [::egglib::readdata $form(pathtof)]]]
	set out [lindex [::egglib::readdata $form(pathtof)] $rn]
	putserv "privmsg $nick : \002#[expr $rn+1]\002/[llength [::egglib::readdata $form(pathtof)]] :"
	foreach line [split $out \|] {
	if { $line != "" } {
	putserv "privmsg $nick :$line"
	}
	}
	return
	}

	if { [regexp -nocase -- {[0-9]+} [::egglib::tolower $text]] } {
	set out [lindex [::egglib::readdata $form(pathtof)] [expr [::egglib::tolower $text]-1]]
	putserv "privmsg $nick : \002#[::egglib::tolower $text]\002/[llength [::egglib::readdata $form(pathtof)]] :"
	foreach line [split $out \|] {
	if { $line != "" } {
	putserv "privmsg $nick :$line"
	}
	}
	return
	}

	}

	if { [string match "*" [::egglib::tolower $text]] || [::egglib::tolower $text] == "stop" } {
	putserv "privmsg $nick :   ."
	set form(q,$uhost) -1
	set form(a,$uhost) ""
	return
	}

	if { [string match "*|*" [::egglib::tolower $text]] } {
	putserv "privmsg $nick :     \002|\002."
	return
	}



	if { [string match "*" [::egglib::tolower $text]] || [::egglib::tolower $text] == "start" } {
	if { [llength $form(quest)] != [llength $form(prefix)] } { return }
		if { $form(q,$uhost) == -1 } {
		set form(q,$uhost) 0
		putserv "privmsg $nick : ,   ."
		putserv "privmsg $nick :    \002! /stop\002."
		putserv "privmsg $nick :    \002! < >\002"
		putserv "privmsg $nick :[lindex $form(quest) $form(q,$uhost)]"
		return
		}
		putserv "privmsg $nick :   .     \002! /stop\002."
		return
	}
	if { $form(q,$uhost) == -1 } {
	putserv "privmsg $nick :  \002! /start\002,    ."
	return
	}
	if { $form(q,$uhost) == 0 } {
	set form(a,$uhost) "[lindex $form(prefix) 0] $text"
	incr form(q,$uhost)
	putserv "privmsg $nick :[lindex $form(quest) $form(q,$uhost)]"
	return
	}
	set form(a,$uhost) "$form(a,$uhost)|[lindex $form(prefix) $form(q,$uhost)] $text"
	incr form(q,$uhost)
	if { $form(q,$uhost) >= [llength $form(quest)] } {
	set data [::egglib::readdata $form(pathtof)]
	set data [linsert $data end $form(a,$uhost)]
	::egglib::writedata $form(pathtof) $data
	putserv "privmsg $nick :    .     \002[llength $data]\002."
	set form(q,$uhost) -1
	return
	}
	if {[lindex $form(quest) $form(q,$uhost)] != "" } {
	putserv "privmsg $nick :[lindex $form(quest) $form(q,$uhost)]"
	}
}